#ifndef _PXI4002_DEVICE_
#define _PXI4002_DEVICE_

#define PXI4002_CAN_MAX_CHANNELS	2 // ֧2·CANͨ
// CAN豸ʼṹ
typedef struct _PXI4002_INIT_PARA_ 
{
	ULONG	WorkMode;		// ʽ=0ʱģʽ=1ʱΪֻģʽ....
	ULONG	AFilterMode;	// ˲ģʽ=0˫˲ģʽ=1˲ģʽ.
	ULONG	SFType;			// ֡ͷ֡ͣ=1ʱΪԷ
	ULONG	CheckCode;		// 
	ULONG	MaskOffCode;	// 
	ULONG	BaudRate;		// , ֵΪ0x09(Զ)ʱʱ0 ʱ1
	ULONG	Timer0;			// ʱ0
	ULONG	Timer1;			// ʱ1
	ULONG	SendMode;		// ģʽ
	ULONG	SendInterval;	// ʱͼuS
	ULONG	TriggerSource;	// Դѡ
	ULONG	SYNCTrigSignal;	// ͬź
	ULONG	TriggerDir;		// 
	ULONG	SYNCTrigOutEn;	// ͬʹ,1:ʹ; 0:ֹ; CAN0 CAN1,Ϊ׼
	ULONG	SYNCTrigOutSrc;	// ͬԴѡ,CAN0 CAN1,Ϊ׼
	ULONG	SYNCTrigOutSel;	// ͬѡ,CAN0 CAN1ü,Ϊ׼
} PXI4002_INIT_PARA, *PPXI4002_INIT_PARA;

// CAN֡ṹ
typedef struct _PXI4002_FRAME_ 
{
	ULONG	FrameFormat;	// ֡ʽ	=0Ϊ֡=1ΪԶ֡
	ULONG	FrameType;		// ֡	=0Ϊ׼֡=1Ϊչ֡
	ULONG	DataLen;		// ݳ <=8
	BYTE	Data[8];		// 
	ULONG	dwID;			// 豸ID
	ULONG	dwSigntime;		// ֡ʱʶ
} PXI4002_FRAME, *PPXI4002_FRAME;

//****************************************************************
// CANʼWorkModeʹùʽѡ
const long PXI4002_WORKMODE_NORMAL		= 0x00;		// ģʽ
const long PXI4002_WORKMODE_LISTEN		= 0x01;		// ֻģʽ
const long PXI4002_WORKMODE_SELFTEST	= 0x02;		// Լģʽ

//****************************************************************
// CANʼAFilterModeʹùʽѡ
const long PXI4002_AFM_DOUBLE			= 0x00;		// ˫˲ģʽ
const long PXI4002_AFM_SINGLE			= 0x01;		// ˲ģʽ

//**********************************	******************************
// CANʼSFTypeʹ÷֡ѡ
const long PXI4002_SFTYPE_NORMAL		= 0x00;		// 
const long PXI4002_SFTYPE_SRSELF		= 0x01;		// Է

//****************************************************************
// CANʼBaudRateʹòѡ
const long PXI4002_BAUD_10KHZ			= 0x00;		// 10Kbps
const long PXI4002_BAUD_20KHZ			= 0x01;		// 20Kbps
const long PXI4002_BAUD_50KHZ			= 0x02;		// 50Kbps
const long PXI4002_BAUD_100KHZ			= 0x03;		// 100Kbps
const long PXI4002_BAUD_125KHZ			= 0x04;		// 125Kbps
const long PXI4002_BAUD_250KHZ			= 0x05;		// 250Kbps
const long PXI4002_BAUD_500KHZ			= 0x06;		// 500Kbps
const long PXI4002_BAUD_800KHZ			= 0x07;		// 800Kbps
const long PXI4002_BAUD_1MHZ			= 0x08;		// 1Mbps
const long PXI4002_BAUD_CUSTOM			= 0x09;		// Զ

//****************************************************************
// CANʼSendModeʹѡ
const long PXI4002_SM_AUTO				= 0x00;		// Զ
const long PXI4002_SM_TIMER				= 0x01;		// ʱ
const long PXI4002_SM_TRIG				= 0x02;		// 

//****************************************************************
// CANʼTriggerSourceʹѡ
const long PXI4002_TS_EXT				= 0x00;		// ⲿ
const long PXI4002_TS_SYNC				= 0x01;		// ͬ

//****************************************************************
// CANʼSYNCTrigSignalʹѡ
const long PXI4002_STS_TRIG0			= 0x00;		// TRIG0
const long PXI4002_STS_TRIG1			= 0x01;		// TRIG1
const long PXI4002_STS_TRIG2			= 0x02;		// TRIG2
const long PXI4002_STS_TRIG3			= 0x03;		// TRIG3
const long PXI4002_STS_TRIG4			= 0x04;		// TRIG4
const long PXI4002_STS_TRIG5			= 0x05;		// TRIG5
const long PXI4002_STS_TRIG6			= 0x06;		// TRIG6
const long PXI4002_STS_TRIG7			= 0x07;		// TRIG7
const long PXI4002_STS_TRIG_STAR		= 0x08;		// TRIG_STAR

//****************************************************************
// CANʼTriggerDirʹѡ
const long PXI4002_TD_NEGATIVE			= 0x00;		// ½ش
const long PXI4002_TD_POSITIVE			= 0x01;		// ش
const long PCI8603_TD_POSIT_NEGAT		= 0x02;		// ½ؾ

//****************************************************************
// CANʼSYNCTrigOutSrcʹѡ
const long PXI4002_STOSEL_EXT			= 0x00;		// ⲿ
const long PXI4002_STOSEL_CAN0_START	= 0x01;		// CAN0_START
const long PXI4002_STOSEL_CAN1_START	= 0x02;		// CAN1_START

//****************************************************************
// CANʼSYNCTrigOutSelʹѡ
const long PXI4002_STOS_TRIG0			= 0x00;		// TRIG0
const long PXI4002_STOS_TRIG1			= 0x01;		// TRIG1
const long PXI4002_STOS_TRIG2			= 0x02;		// TRIG2
const long PXI4002_STOS_TRIG3			= 0x03;		// TRIG3
const long PXI4002_STOS_TRIG4			= 0x04;		// TRIG4
const long PXI4002_STOS_TRIG5			= 0x05;		// TRIG5
const long PXI4002_STOS_TRIG6			= 0x06;		// TRIG6
const long PXI4002_STOS_TRIG7			= 0x07;		// TRIG7


//****************************************************************
// CAN֡FrameFormatʹ֡ʽѡ
const long PXI4002_FFORMAT_DATA			= 0x00;		// ֡
const long PXI4002_FFORMAT_REMOTE		= 0x01;		// Զ֡

//****************************************************************
// CAN֡FrameTypeʹ֡ѡ
const long PXI4002_FTYPE_STANDARD		= 0x00;		// ׼֡
const long PXI4002_FTYPE_EXTEND			= 0x01;		// չ֡

//****************************************************************
// ֵ֡
const long PXI4002_BUFFER_FULL			= 0;		// ֡
const long PXI4002_SENDFRM_ERR			= -1;		// ֡


//***********************************************************
// ûӿ
#ifndef _PXI4002_DRIVER_
#define DEVAPI __declspec(dllimport)
#else
#define DEVAPI __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
	//######################## ͨú #################################
	// ڱ豸
	HANDLE DEVAPI FAR PASCAL PXI4002_CreateDevice(int DeviceID = 0);		// 豸
	LONG DEVAPI FAR PASCAL PXI4002_GetDeviceCount(HANDLE hDevice);			// ȡ豸̨
	BOOL DEVAPI FAR PASCAL PXI4002_GetDeviceCurrentID(HANDLE hDevice, PLONG DeviceLgcID, PLONG DevicePhysID);
	BOOL DEVAPI FAR PASCAL PXI4002_ListDeviceDlg(HANDLE hDevice);			// бϵͳееĸPCI豸
    BOOL DEVAPI FAR PASCAL PXI4002_ReleaseDevice(HANDLE hDevice);			// ر豸,ֹ,ͷԴ

	//############################## CAN #################################
	BOOL DEVAPI FAR PASCAL PXI4002_ResetDevice(							// λ豸븴λģʽ
											HANDLE	hDevice,			// 豸
											LONG lChannel);				// CANͨ[0~1]

	BOOL DEVAPI FAR PASCAL PXI4002_InitCAN(								// ʼCAN빤ģʽ
											HANDLE hDevice,					// 豸
											PPXI4002_INIT_PARA pPara,		// ʼ
											LONG lChannel);					// CANͨ[0~1]

	LONG DEVAPI FAR PASCAL PXI4002_SendFrame(						// ͵֡(ֵ: ɹ: ֽ	ʧ: 0)
											HANDLE hDevice,					// 豸
											PPXI4002_FRAME psCanFrame,	// CAN֡
											PLONG pSts,						// ״̬Ϣ
											double dTimeOut,				// ͳʱλms
											LONG lChannel);					// CANͨ[0~1]
	
	LONG DEVAPI FAR PASCAL PXI4002_ReceiveFrame(							// ֡(: ɹ: ֽ	ʧ: 0	)
											HANDLE hDevice,					// 豸
											PPXI4002_FRAME pCanFrame,		// CAN֡
											PLONG pSts,						// ״̬Ϣ
											double dTimeOut,				// ͳʱλms
											LONG lChannel);					// CANͨ[0~1]


	//############################## CANдַݲ #################################
	BOOL DEVAPI FAR PASCAL PXI4002_DEV_Write(								// дCANĴ
											HANDLE hDevice,					// 豸
											BYTE bAddr,						// ַ
											BYTE bData,						// 
											LONG lChannel);					// CANͨ[0~1]
	BYTE DEVAPI FAR PASCAL PXI4002_DEV_Read(								// CANĴ
											HANDLE hDevice,					// 豸
											BYTE bAddr,						// ַ
											LONG lChannel);					// CANͨ[0~1]



	//################# ڴӳĴֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	BOOL DEVAPI FAR PASCAL PXI4002_GetDeviceBar(							// ȡָָ豸ĴBARַ
											HANDLE hDevice,					// 豸,CreateDevice
											__int64 pbPCIBar[6]);			// PCI BARеַ,PCI BARжٿõַ뿴Ӳ˵
	BOOL DEVAPI FAR PASCAL PXI4002_GetDevVersion(							// ȡ豸̼汾
											HANDLE hDevice,					// 豸,CreateDevice
											PULONG pulFmwVersion,			// ̼汾
											PULONG pulDriverVersion);		// 汾

	BOOL DEVAPI FAR PASCAL PXI4002_WriteRegisterByte(						// ָĴռλд뵥
											HANDLE hDevice,					// 豸,CreateDevice
											__int64 LinearAddr,				// ָĴԻַ,GetDeviceAddrеLinearAddrֵ
											ULONG OffsetBytes,				// Իַַƫλ(ֽ)
											BYTE Value);					// ַָд뵥ֽݣַԻַƫλþ

	BOOL DEVAPI FAR PASCAL PXI4002_WriteRegisterWord(						// д˫ֽݣͬϣ
											HANDLE hDevice, 
											__int64 LinearAddr, 
											ULONG OffsetBytes,  
											WORD Value);

	BOOL DEVAPI FAR PASCAL PXI4002_WriteRegisterULong(					// дĽݣͬϣ
											HANDLE hDevice, 
											__int64 LinearAddr, 
											ULONG OffsetBytes,  
											ULONG Value);

	BYTE DEVAPI FAR PASCAL PXI4002_ReadRegisterByte(						// 뵥ֽݣͬϣ
											HANDLE hDevice, 
											__int64 LinearAddr, 
											ULONG OffsetBytes);

	WORD DEVAPI FAR PASCAL PXI4002_ReadRegisterWord(						// ˫ֽݣͬϣ
											HANDLE hDevice, 
											__int64 LinearAddr, 
											ULONG OffsetBytes);

	ULONG DEVAPI FAR PASCAL PXI4002_ReadRegisterULong(					// ֽݣͬϣ
											HANDLE hDevice, 
											__int64 LinearAddr, 
											ULONG OffsetBytes);

	//########################### ̲߳ ######################################
	HANDLE DEVAPI FAR PASCAL PXI4002_CreateSystemEvent(void);				// ں¼󣬹InitDeviceIntVB̵߳Ⱥʹ
	BOOL DEVAPI FAR PASCAL PXI4002_ReleaseSystemEvent(HANDLE hEvent);		// ͷں¼


#ifdef __cplusplus
}
#endif

// Զ
#ifndef _PXI4002_DRIVER_
	#ifndef _WIN64
		#pragma comment(lib, "PXI4002_32.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with PXI4002_32.dll...")
		#pragma message("======== Successfully linked with PXI4002_32.dll")
	#else
		#pragma comment(lib, "PXI4002_64.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with PXI4002_64.dll...")
		#pragma message("======== Successfully linked with PXI4002_64.dll")
	#endif

#endif

#endif // _PXI4002_DEVICE_
